﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;	
	import flash.geom.ColorTransform;

	public class Lissajou extends Sprite
	{
		private var background:Bitmap;
		private var data:BitmapData;
		private var horizontal_support:Sprite;
		private var horizontal_angle:Number = 0;
		private var vertical_support:Sprite;
		private var vertical_angle:Number = 0;
		private var canevas:Sprite;
		private var vitesseH:Number;
		private var vitesseV:Number;
		private var red:Number;
		private var green:Number;
		private var blue:Number;
		private var inc:Number=0;
		private var modulo:Number=10;
		private var positifNegatif:Number=1;
		private var modulo2:Number=10;
		private var positifNegatif2:Number=1;
		private var modulo3:Number=10;
		private var positifNegatif3:Number=1;
		private var modulo4:Number=15;
		private var positifNegatif4:Number=1;
		
		private var avant:String;
		private var apres:String;
		private var string:String;
		private var r:Number=0;
		private var w:Number=0;
		private var raptissi:Number=0;
		private var raptissi2:Number=0;
		private var descen:Number=0;
		
		
		public function Lissajou()
		{
			data = new BitmapData(600,600,false,0x000000);
			background = new Bitmap(data);
			
			addChild(background);
			canevas = new Sprite();	
			addChild(canevas);
			
			vitesseH = 1;
			vitesseV = 1;
			
			
			buildHorizontalMovement();
		}
		
		private function buildHorizontalMovement():void
		{
			horizontal_support = new Sprite();
			horizontal_support.x= 0;
			horizontal_support.y= 25;
			
			canevas.addChild(horizontal_support);
			
			horizontal_support.addEventListener(Event.ENTER_FRAME,horizontal_enter_handler);
			
			buildVerticalMovement(horizontal_support);
		}
		
		private function horizontal_enter_handler(e:Event):void
		{
			//_________________________________________modulo pour les allé retours de couleur + de l'axe X
			//__modulo pour red 	(couleur rouge)
			//__modulo3 pour blue 	(couleur bleu)
			//__modulo4 pour allé retour axe X
			
			if (modulo % 125 == 0) {positifNegatif*= -1;}
			if (modulo3 % 250 == 0) {positifNegatif3*= -1;}
			if (modulo4 % 60 == 0) {positifNegatif4*= -1;}
			modulo += positifNegatif;
			modulo3+= positifNegatif3;
			modulo4+= positifNegatif4;
			//________________________________________FIN modulo

			//________________________________________modification de couleur pour obtenir le dégrader
			if (descen==520){
			trace("KARIAN_MERCI_POUR_METROID");
			red = 0;
			green = 0;
			blue = 0;
			}else{
			red = modulo/100;
			green = raptissi2/200;
			blue = modulo3/90;
			}
			//________________________________________FIN modification de couleur

			//________________________________________cretion du carre (allé retour axe Y et saut axe X)
			//__r = axe Y
			//__w = axe X
			avant = string;
		
			if(r==0 && w<250){
			string="a";
			w+=250;
			r+=0;
			}else if(r<250 && w==250){
			string="b";
			w+=0;
			r+=1;
			}else if(r==250 && w<251 && w>0){
			string="c";
			w-=250;
			r+=0;
			}else if(r<251 && w==0){
			string="d";
			w+=0;
			r-=1;
			}
			
			apres = string
				
			if (avant=="d" && apres == "a" && descen!=260){
			raptissi += 20;
			raptissi2 += 20;
			}
			if (raptissi == 240){
			trace("R")
			descen += 260;
			raptissi = 0;
			raptissi2 += 60;
			}
			if(avant=="d" && apres == "a" && descen==260){
			trace("YO")
			raptissi += 20;
			raptissi2 -= 20;
			}
			//________________________________________FIN cretion du carre		
			
			
			horizontal_angle+=vitesseH;
			e.currentTarget.scaleX=10;
			e.currentTarget.transform.colorTransform = new ColorTransform(red,green,blue,1, 0, 1, 0, 0);
			e.currentTarget.x = w+raptissi+modulo4+30;
		}
		
		private function buildVerticalMovement(clip:Sprite):void
		{
			vertical_support = new Sprite();
			vertical_support.graphics.beginFill(0x999999,1);
			vertical_support.graphics.drawCircle(0,0,1);
			vertical_support.graphics.endFill();
			clip.addChild(vertical_support);
			vertical_support.addEventListener(Event.ENTER_FRAME,vertical_enter_handler);
		}
		
		private function vertical_enter_handler(e:Event):void
		{
			vertical_angle+=vitesseV;
			e.currentTarget.scaleY=10;
			e.currentTarget.alpha=modulo4/250;
			e.currentTarget.y = r+descen+20;
			data.draw(canevas);
		}
	}
}